function  [aOpt,bOpt,thOpt,jOpt,kOpt,TOpt,ClassSetOut,NegClassSetOut]  = fitJointTemporalStumpC(x, z, w , TemporalSupport,y,Combinations);
% [th, a , b] = fitRegressionStump(x, z, w, TemporalSupport);
% The regression has the form:
% h_hat(x_(i)) = 1/T * sum_(t=0)^(T-1) (a * (x_(i-t)>th) + b * (x_(i-t)<=th) );
%
% where (a,b,th) are so that it minimizes the weighted error:
% error = sum(w * (z -1/T * sum_(t=0)^(T-1) (a * (x_(i-t)>th) + b * (x_(i-t)<=th) ) )^2)
%
% maximum T = TemporalSupport * Nsamples;
% x,z and w are vectors of the same length
% x, and h are real values.
% z = {-1,1}.
% w is a weight of positive values. There is no asumption that it sums to
% one.

%  Pedro & Plinio, 2006-2009

[Nfeatures, Nsamples] = size(x); % Nsamples = Number of thresholds that we will consider
[xSorted, j] = sort(x); % this now becomes the thresholds. I assume that all the values are different.
%%%%%%%%%%%5
% minx=xSorted(1);maxx=xSorted(end);
% thresh_=minx:(maxx-minx)/100:maxx;
%%%%%%%%%%%%%%%%%%

[thresh_ qq]=unique(xSorted);

if length(thresh_) > 2
 thresh=thresh_(2:end-1);
elseif length(thresh_) == 2
 thresh=thresh_(1);
elseif length(thresh_) < 2
    error('The feature does not have enough different values to compute the optimal stump');
end

%for all possible values of T (1, ..., T)
MaxT =TemporalSupport;% floor(TemporalSupport * Nsamples);
Nthre = length(thresh);

[aOpt,bOpt,jOpt,kOpt,nOpt,TOpt,thOpt]=fitJointTemporalStumpOptimized(single(MaxT),single(x),single(w),single(z),single(thresh),single(thresh),single(y));
% nOpt=nOpt+1;
% TOpt=TOpt+1;
%  [aOpt,bOpt,jOpt,kOpt,nOpt,TOpt,thOpt]=fitJointTemporalStumpNewDebug3(single(MaxT),single(x),single(w),single(z),single(thresh),single(thresh),single(y));

% [aS,bS,jS,kS,nS,tS,thS]=fitJointTemporalStumpNewDebug2(single(MaxT),single(x),single(w),single(z),single(thresh),single(thresh),single(y));
% [aS,bS,jS,kS,nS,tS,thS]=fitjointtemporalstumpnewdebug2(single(MaxT),singl
% e(x),single(w),single(z),single(thresh),single(thresh),single(y));
% sprintf('N = %d',nOpt)
% sprintf('T = %d',TOpt)
%%%%%%%%%%%%%%%%%
Nclass=size(z,1);
    ClassSetOut = Combinations(nOpt).classes;
NegVec=ones(1,Nclass);
NegVec(ClassSetOut)=0;
NegClassSetOut=find(NegVec);




% MaxT=single(MaxT);
% x=single(x);
% w=single(w);
% z=single(z);
% thresh=single(thresh);
% y=single(y);
% 
% Nclass=size(z,1);
% WZ=w.*z;
% Classes = [1:Nclass];
% IV=single(zeros(1,Nthre));
% n=1;
% for NumClassInSet=1:Nclass-1
%     Combs = combnk(Classes,NumClassInSet);
%     for c=1:size(Combs,1)
%         ClassSet = Combs(c,:);
%         Combinations(n).classes=ClassSet;
%         NegVec=ones(1,Nclass);
%         NegVec(ClassSet)=0;
%         NegClassSet=find(NegVec);
%         k(ClassSet,n)=single(0);
%         k(NegClassSet,n)=single(sum(WZ(NegClassSet,:),2)./sum(w(NegClassSet,:),2));
%         for T = 1:MaxT
%             for i = T:Nsamples
%                 for thI=1:Nthre
%                     if prod(double(y(i-T+1:i)==y(i)))==1
%                         PHI( i , thI ,T) = length( find( x(i-T+1:i) > thresh(thI) ) );
%                         CHI( i , thI ,T) = length( find( x(i-T+1:i) <= thresh(thI) ) );
%                     end
%                 end
%             end
%             WZPHI(T,:)=IV;WZCHI(T,:)=IV;WPHI(T,:)=IV;WCHI(T,:)=IV;WPHCH(T,:)=IV;
%             for CurrClass=ClassSet
%                 WZPHI(T,:) = WZPHI(T,:) + WZ(CurrClass,:)* PHI(:,:,T);
%                 WZCHI(T,:) = WZCHI(T,:) + WZ(CurrClass,:)* CHI(:,:,T);
%                 WPHI(T,:)   = WPHI(T,:) + w(CurrClass,:)  * PHI(:,:,T).^2;
%                 WCHI(T,:)   = WCHI(T,:) + w(CurrClass,:)   * CHI(:,:,T).^2;
%                 WPHCH(T,:) = WPHCH(T,:) + w(CurrClass,:) * (PHI(:,:,T).*CHI(:,:,T));
%             end
%             WPHCHsq = WPHCH.^2;
%             %compute a and b for all the possible values of T and theta
%             norm=single(WPHI.*WCHI-WPHCHsq);
%             a=(WZPHI.*WCHI-WZCHI.*WPHCH)./norm;
%             b=(WPHI.*WZCHI-WZPHI.*WPHCH)./norm;
%             for JthI=1:Nthre
%                 J(T,JthI)=single(0);
%                 for CL=1:Nclass
%                     if ~isempty(find(CL==ClassSet))
%                         J(T,JthI) = J(T,JthI) + sum(w(CL,:).*(z(CL,:)  - ( a(T,JthI) * PHI(:,JthI,T)'   + b(T,JthI) * CHI(:,JthI,T)' )/T ).^2 );
%                     else
%                         J(T,JthI) = J(T,JthI) + sum(w(CL,:).*(z(CL,:) - k(CL,n) ).^2 );
%                     end
%                 end
%             end
%             
%             
%             %find minimum
%             [val indMin]=min(J(T,:));
%             aTn(T,n)=a(T,indMin);
%             bTn(T,n)=b(T,indMin);
%             thTn(T,n)=thresh(indMin);
%             JTn(T,n)=J(T,indMin);
%         end
%         n=n+1;
%     end
% end
% %find minimum
% [vec1 ind1]=min(JTn);
% [vec2 ind2]=min(vec1);
% TOpt=ind1(ind2);nOpt=ind2;
% aOpt=aTn(TOpt,nOpt);
% bOpt=bTn(TOpt,nOpt);
% thOpt=thTn(TOpt,nOpt);
% jOpt=JTn(TOpt,nOpt);
% kOpt=k(:,nOpt);
% ClassSetOut = Combinations(nOpt).classes;
% NegVec=ones(1,Nclass);
% NegVec(ClassSetOut)=0;
% NegClassSetOut=find(NegVec);










