function [featureNdx, th, a , b, kc ,T,ClassSet, NegClassSet, error] = selectBestJointTemporalDecisionStumpC(x, z, w,TS,y,Combinations);
% [th, a , b] = fitRegressionStump(x, z);
% z = a * (x>th) + b;
%
% where (a,b,th) are so that it minimizes the weighted error:
% error = sum(w * |z - (a*(x>th) + b)|^2) / sum(w)

% atb, 2003
% torralba@ai.mit.edu

[Nfeatures, Nsamples] = size(x); % Nsamples = Number of thresholds that we will consider
% w = w/sum(w); % just in case...

th = zeros(1,Nfeatures);
a = zeros(1,Nfeatures);
b = zeros(1,Nfeatures);
error = zeros(1,Nfeatures);
k = zeros(size(z,1),Nfeatures);
T=zeros(1,Nfeatures);
% ClassSet = [];
% NegClassSetOut=[];
for feat = 1:Nfeatures
    disp(['Computing feature n ' sprintf('%d\n',feat)]);
%     tic
    [a(feat),b(feat),th(feat),error(feat),k(:,feat),T(feat) ,ClassSet(feat).cl,NegClassSetOut(feat).cl] = fitJointTemporalStumpC(x(feat,:), z, w,TS,y,Combinations);
%     toc
end

[error, featureNdx] = min(error);
th = th(featureNdx);
a = a(featureNdx);
b = b(featureNdx);
kc = k(:,featureNdx);
ClassSet = ClassSet(featureNdx).cl;
NegClassSet = NegClassSetOut(featureNdx).cl;
T=T(featureNdx);